/*
 * $Log$
 *
 *
 */

#include <stdio.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL_rotozoom.h>
#include <math.h>

#define PI  3.14159265358979

#define SW 800
#define SH 600


SDL_Surface *screen,*ship;

SDL_Surface *ships[359];

int
init_sdl()
{
    /* SDL INIT */
    printf("Initialising SDL...");
    /* Initialize defaults, Video and Audio */
    if ((SDL_Init(SDL_INIT_VIDEO) == -1)) {
        printf("Error: %s.\n", SDL_GetError());
        return 0;
    } else
        printf("Done.\n");
                                                                                                                                                            
    atexit(SDL_Quit);
    screen = SDL_SetVideoMode(SW, SH, 16, SDL_HWSURFACE);
    if (screen == NULL) {
        printf("Couldn't set video mode: %s\n", SDL_GetError());
        return 0;
    }
	SDL_EnableKeyRepeat(1,1);
    //SDL_WM_SetCaption(screen,"Space fucks test 1");
    //SDL_WM_ToggleFullScreen(screen);
    return 1;
}


/* Function int main(int argc, char **argv) {{{ */
int main(int argc, char **argv)
{
	SDL_Event event;
	SDL_Rect r;
	int quit=0;
	int direction=90;
	int i;
	float x_vec=0.0,y_vec=0.0,thrust=1.0;

	init_sdl();

	/* Load ship and create rotations */
	ships[0] = IMG_Load("ship1a.png");
	for (i=0; i<360; i++)
		ships[i] = rotozoomSurface(ships[0],i,1,1);

	while (!quit) {

		
		/* Handle SDL events */
		while (SDL_PollEvent(&event)) {
			if ( event.type == SDL_QUIT )
				quit = 1;
			if ( event.type == SDL_KEYDOWN || event.type == SDL_KEYUP )
				switch (event.key.keysym.sym) {
					case SDLK_ESCAPE:
						quit = 1;
						break;
					case SDLK_RIGHT:
						direction -= 5;
						break;
					case SDLK_LEFT:
						direction += 5;
						break;
					case SDLK_UP:
						thrust += 0.1;
						break;
					case SDLK_DOWN:
						thrust -= 0.1;
						break;
					default:
						break;
				};
			if (direction < 0) direction = 359;
		}

		ship = ships[(direction+180) % 359];
		/* increase x and y depending on direction angle and thrust */
		y_vec += cos(direction * (2 * PI) / 360) * thrust;
		x_vec += sin(direction * (2 * PI) / 360) * thrust;
		
		/* Wrapping */
		if (x_vec > SW + ship->w) x_vec = -ship->w;
		if (y_vec > SH + ship->h) y_vec = -ship->h;
		if (x_vec < -ship->w) x_vec = SW + ship->w;
		if (y_vec < -ship->h) y_vec = SH + ship->h;

		r.x=ceil(x_vec) - (ship->w / 2);
		r.y=ceil(y_vec) - (ship->h / 2);
		
		SDL_FillRect(screen, NULL, 0);
		SDL_BlitSurface(ship,NULL,screen,&r);
		//SDL_Flip(screen);
		SDL_UpdateRect(screen, 0,0,0,0);

	};

	return 0;
} /* }}} */


/* Modeline for ViM {{{
 * vim:set ts=4:
 * vim600:fdm=marker fdl=0 fdc=3:
 * }}} */


